#![allow(deprecated)]
use std::fmt;
use std::str;
/// Why a particular data source within the dataset does not support streaming.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum StreamingNotSupportedReason {
    #[serde(rename = "DATASET_DOES_NOT_ALLOW_STREAMING")]
    DatasetDoesNotAllowStreaming,
    #[serde(rename = "CONNECTION_TYPE_NOT_NOMINAL")]
    ConnectionTypeNotNominal,
    #[serde(rename = "CONNECTION_TIMESTAMP_TYPE_NOT_ABSOLUTE")]
    ConnectionTimestampTypeNotAbsolute,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl StreamingNotSupportedReason {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            StreamingNotSupportedReason::DatasetDoesNotAllowStreaming => {
                "DATASET_DOES_NOT_ALLOW_STREAMING"
            }
            StreamingNotSupportedReason::ConnectionTypeNotNominal => {
                "CONNECTION_TYPE_NOT_NOMINAL"
            }
            StreamingNotSupportedReason::ConnectionTimestampTypeNotAbsolute => {
                "CONNECTION_TIMESTAMP_TYPE_NOT_ABSOLUTE"
            }
            StreamingNotSupportedReason::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for StreamingNotSupportedReason {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for StreamingNotSupportedReason {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for StreamingNotSupportedReason {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<StreamingNotSupportedReason, conjure_object::plain::ParseEnumError> {
        match v {
            "DATASET_DOES_NOT_ALLOW_STREAMING" => {
                Ok(StreamingNotSupportedReason::DatasetDoesNotAllowStreaming)
            }
            "CONNECTION_TYPE_NOT_NOMINAL" => {
                Ok(StreamingNotSupportedReason::ConnectionTypeNotNominal)
            }
            "CONNECTION_TIMESTAMP_TYPE_NOT_ABSOLUTE" => {
                Ok(StreamingNotSupportedReason::ConnectionTimestampTypeNotAbsolute)
            }
            v => v.parse().map(|v| StreamingNotSupportedReason::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for StreamingNotSupportedReason {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<StreamingNotSupportedReason, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the StreamingNotSupportedReason enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
